﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDiagramProjectEmployeesDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;
        }

        private void XamDiagram_NodeMoved(object sender, DiagramNodeMovedEventArgs e)
        {

            DiagramNode node = e.Node;

            if (node != null)
            {
                NodeItem item = node.Content as NodeItem;

                if(item != null && item.IsEmployee) 
                {
                    Point newPosition = e.NewPosition;

                    Rect movedBounds = new Rect(newPosition.X, newPosition.Y, node.ActualWidth, node.ActualHeight);

                    List<DiagramItem> projectNodes = diagram.Items.Where(x => x.Content is NodeItem && ((NodeItem)x.Content).IsProject).ToList();        

                    foreach(var x in projectNodes)
                    {
                        if(x is DiagramNode)
                        {
                            DiagramNode projNode = x as DiagramNode;
                            Point projPosition = projNode.Position;

                            Rect projRect = new Rect(projPosition.X, projPosition.Y, projNode.ActualWidth, projNode.ActualHeight);

                            if (projRect.IntersectsWith(movedBounds))
                            {
                                item.AssociatedProject = x.Content as NodeItem;
                                vm.Links.Add(new ProjectLink() { FromNode = x.Content as NodeItem, ToNode = item });
                                break;
                            }
                        }
                    }


                    List<DiagramNode> allNodes = new List<DiagramNode>();
                    foreach(DiagramItem diItem in diagram.Items)
                    {
                        if(diItem is DiagramNode)
                        {
                            allNodes.Add(diItem as DiagramNode);
                        }
                    }

                    diagram.Layout.ArrangeNodes(allNodes);
                }
            }
        }
    }
}
