﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDiagramProjectEmployeesDemo
{
    public class ViewModel
    {
        public ObservableCollection<NodeItem> NodeItems { get; set; }
        public ObservableCollection<ProjectLink> Links { get; set; }


        string[] names = "Andrew;Steve;Eric;Tom;Devin;Emilie;Pamela;Valerie".Split(';');
        public ViewModel()
        {
            NodeItems = new ObservableCollection<NodeItem>();
            Links = new ObservableCollection<ProjectLink>();

            NodeItem item = new NodeItem() { DisplayName = "Project 1", IsEmployee = false, IsProject = true, AssociatedProject = null };
            NodeItem item2 = new NodeItem() { DisplayName = "Project 2", IsEmployee = false, IsProject = true, AssociatedProject = null };

            NodeItems.Add(item);
            NodeItems.Add(item2);

            for(int i=0; i < names.Length; i++)
            {
                NodeItem empItem = new NodeItem() { DisplayName = names[i], IsEmployee = true, IsProject = false, AssociatedProject = null };
                NodeItems.Add(empItem);
            }
        }
    }


    public class NodeItem
    {
        public string DisplayName { get; set; }
        public bool IsProject { get; set; }
        public bool IsEmployee { get; set; }     
        public NodeItem AssociatedProject { get; set; }   
    }

    public class ProjectLink
    {
        public NodeItem FromNode { get; set; }
        public NodeItem ToNode { get; set; }
    }
}
